<template>
  <div class="SnippetsTab _tabcontent">
    <tab-simple
      v-model="items"
      :is-tab-active="isTabActive"
      :item-title="'L: copy to clipboard, R: open in sublime'"
      @leftClick="leftClick"
      @rightClick="rightClick"
      @middleClick="middleClick"
      @create="createItem"
      @onTabActive="onTabActive"
      tab-name="snippets"
      single-item="snippet">
      <template slot="controls" slot-scope="prop">
        <i @click="renameItem(prop.item)" class="fa fa-pencil-square-o" title="rename snippet" aria-hidden="true"></i>
        <i @click="deleteItem(prop.item)" class="fa fa-trash" title="delete snippet" aria-hidden="true"></i>
      </template>
    </tab-simple>
  </div>
</template>

<script>
import TabSimple from '@/components/ui/TabBar/TabSimple/TabSimple'

export default {
  components: {
    TabSimple
  },
  props: {
    value: {
      default: () => ([])
    },
  },
  data() {
    return {
      loading: true
    }
  },
  computed: {
    isTabActive() {
      return this.$parent.active
    },
    items: {
      get() {
        return this.value
      },
      set() {
        this.$emit('input', this.value)
      }
    }
  },
  methods: {
    onTabActive() {},
    async leftClick(item) {
      await this.$axios.post(`/snippets/copy/${item.name}`)
      win.close()
    },
    async rightClick(item) {
      await this.$axios.post(`/snippets/open/${item.name}`, {
        newWin: true
      })
      win.close()
    },
    async middleClick(item) {
      await this.$axios.post(`/snippets/open/${item.name}`)
    },
    createItem() {
      const router = this.$router || $nuxt.$router
      router.push({
        path: '/save-snippet',
      })
    },
    renameItem(item) {
      this.$prompt(`Rename "${item.name}" snippet to:`, '', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        inputPattern: /^[^\\\/\:\*\?\"\<\>\|\.]+$/,
        inputErrorMessage: 'Invalid snippet name'
      }).then(async (data) => {
        const newSnippetName = data.value
        if (newSnippetName && newSnippetName !== item.name) {
          await this.$axios.post(`/snippets/rename/${item.name}`, {
            newName: data.value
          })
          const index = _.findIndex(this.items, { name: item.name })
          this.items.splice(index, 1, { name: newSnippetName })
        }
      }).catch(e => {})
    },
    deleteItem(item) {
      this.$confirm(`Delete snippet ${item.name}. Continue?`, 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(async () => {
        await this.$axios.post(`/snippets/delete/${item.name}`)
        const index = _.findIndex(this.items, { name: item.name })
        this.items.splice(index, 1)
      })
    },
  }
}
</script>

<style>
@import "./SnippetsTab.less";
</style>